//
//  FollowMeView.m
//  Follow Me
//
//  Created by Matt Long on 10/22/08.
//

#import "FollowMeView.h"


@implementation FollowMeView

- (id)initWithFrame:(NSRect)frame {
    if(![super initWithFrame:frame]) return nil;

    return self;
}

- (void)awakeFromNib;
{
    [self setWantsLayer:YES];
    
    objectLayer = [CALayer layer];
    [objectLayer setDelegate:self];
    [objectLayer setCornerRadius:15];
    [objectLayer setBounds:CGRectMake(0, 0, 30, 30)];
    [objectLayer setPosition:CGPointMake( 55, 55 )];
    [objectLayer setBackgroundColor:CGColorCreateGenericRGB(0, 0, 0, 1)];

    [[self layer] addSublayer:objectLayer];
}

- (BOOL)acceptsFirstResponder;
{
    return YES;
}

- (void)mouseDown:(NSEvent*)event;
{
    CABasicAnimation *animation = 
            [CABasicAnimation animationWithKeyPath:@"position"];
    [animation setDelegate:self];

    // Get the presentationLayer
    CALayer *p = (CALayer*)[objectLayer presentationLayer];
    CGPoint position = [p position];
    NSValue *prevVal = [NSValue valueWithPoint:
                        NSPointFromCGPoint(position)];

    [animation setFromValue:prevVal];
    NSPoint point = NSMakePoint(
                                [event locationInWindow].x, 
                                [event locationInWindow].y);
    
    [animation setToValue:[NSValue valueWithPoint:point]];
    [animation setDuration:2.0];
    
    [objectLayer addAnimation:animation forKey:@"follow"];
}

- (void)animationDidStop:(CAAnimation *)theAnimation finished:(BOOL)flag
{
    NSLog(@"Animation interrupted: %@", (!flag)?@"Yes" : @"No");
}

@end
